<template>
  <form @submit.prevent="tryRegister" novalidate>
    <page-title class="title" :title="'Registreren'"></page-title>
    <FormField id="name"
               v-model="name"
               type="text"
               :required="true"
               label="Naam"
               :error="nameError"></FormField>
    <FormField id="surname"
               v-model="surname"
               type="text"
               :required="true"
               label="Voornaam"
               :error="surnameError"></FormField>
    <FormField id="email"
               v-model="email"
               type="email"
               :required="true"
               label="Email"
               :error="emailError"></FormField>
    <FormField id="password"
               v-model="password"
               type="password"
               :required="true"
               label="Wachtwoord"
               :error="passwordError"></FormField>
    <FormField id="reppassword"
               v-model="reppassword"
               type="password"
               :required="true"
               label="Herhaal Wachtwoord"
               :error="reppasswordError"></FormField>
    <button type="submit">Registreren</button>
    <div class="loading" v-show="loading" role="alert">
      <loading></loading>
    </div>
    <Error v-if="error" :value="error"></Error>
  </form>
</template>

<script>

import FormField from '@/components/UI/molecules/FormField.vue';
import Error from '@/components/UI/atoms/Error.vue';
import PageTitle from '@/components/UI/atoms/PageTitle.vue';

import { mapActions } from 'vuex';

import Loading from '@/components/UI/atoms/Loading.vue';

const emailRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

export default {
  name: 'RegisterForm',
  components: {
    Loading,
    PageTitle,
    FormField,
    Error,
  },
  data() {
    return {
      email: null,
      password: null,
      reppassword: null,
      name: null,
      surname: null,
      error: null,
      loading: false,
      submitted: false,
    };
  },
  computed: {
    nameError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.name) {
        return 'Naam is een verplicht veld.';
      }
      return null;
    },
    surnameError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.surname) {
        return 'Voornaam is een verplicht veld.';
      }
      return null;
    },
    emailError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.email) {
        return 'Email is een verplicht veld.';
      }
      if (!emailRegex.test(this.email)) {
        return 'Geef een geldige Email';
      }
      return null;
    },
    passwordError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.password) {
        return 'Wachtwoord is een verplicht veld.';
      }
      if (this.password.length < 8) {
        return 'Wachtwoord moet langer zijn dan 8 karakters';
      }
      return null;
    },
    reppasswordError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.reppassword) {
        return 'Herhaal Wachtwoord is een verplicht veld.';
      }
      if (this.reppassword !== this.password) {
        return 'Wachtwoorden komen niet overeen.';
      }
      return null;
    },
    hasErrors() {
      return this.nameError
        || this.surnameError
        || this.emailError
        || this.passwordError
        || this.reppasswordError;
    },
  },
  methods: {
    ...mapActions('auth', ['register']),
    async tryRegister() {
      this.submitted = true;
      if (this.hasErrors) {
        return;
      }
      this.loading = true;
      try {
        await this.register({
          surname: this.surname,
          name: this.name,
          email: this.email,
          password: this.password,
        });
      } catch (e) {
        if (e.response.status === 422) {
          this.error = 'De gegeven data is niet juist.';
          return;
        }
        this.error = 'Er is een onverwachte fout opgetreden.';
      } finally {
        this.loading = false;
        await this.$router.push({ name: 'Dashboard' });
      }
    },
  },
};
</script>

<style scoped lang="scss">
  form{
    max-width: 320px;
  }
  .title{
    font-size: 4em;
  }
  button{
    width: 120px;
    height: 42px;
    font-family: 'Roboto', sans-serif;
    font-size: 20px;
    border: none;
    border-radius: 6px;
    background-color: $custom_red;
    color: #FFFFFF;
    margin-top: 30px;
  }
  button:hover{
    opacity: 0.8;
  }
  .loading{
    display: flex;
    justify-content: center;
    align-items: center;
    background-color: rgba(1, 1, 1, 0.2);
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
  }
</style>
